Index: src/main/java/de/mpiwg/itgroup/annotations/neo4j/AnnotationStore.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/neo4j/AnnotationStore.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/neo4j/AnnotationStore.java	(revision 75)
@@ -33,6 +33,6 @@
 import java.util.List;
 import java.util.Set;
-
-import org.apache.log4j.Logger;
+import java.util.logging.Logger;
+
 import org.neo4j.graphdb.Direction;
 import org.neo4j.graphdb.GraphDatabaseService;
@@ -62,5 +62,5 @@
 public class AnnotationStore {
 
-    protected static Logger logger = Logger.getLogger(AnnotationStore.class);
+    protected static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.neo4j.AnnotationStore");
 
     protected GraphDatabaseService graphDb;
@@ -320,5 +320,5 @@
             // make sure we're getting a group
             if (!(group instanceof Group)) {
-                logger.error("target of MEMBER_OF is not GROUP! rel=" + rel);
+                logger.severe("target of MEMBER_OF is not GROUP! rel=" + rel);
                 continue;
             }
@@ -370,5 +370,5 @@
             // make sure we're getting a group
             if (!(member instanceof Person)) {
-                logger.error("source of MEMBER_OF is not PERSON! rel=" + rel);
+                logger.severe("source of MEMBER_OF is not PERSON! rel=" + rel);
                 continue;
             }
@@ -485,5 +485,5 @@
                     deleteNode(actorNode);
                 } else {
-                    logger.error("deleteActor: unable to delete: Node still has relations.");
+                    logger.severe("deleteActor: unable to delete: Node still has relations.");
                 }
                 tx.success();
@@ -533,5 +533,5 @@
             }
             if (annot.getTarget() == null) {
-                logger.warn("annotation " + annotNode + " has no target node!");
+                logger.warning("annotation " + annotNode + " has no target node!");
             }
             // get fragment from attribute
@@ -550,5 +550,5 @@
                 annot.setCreator(creator);
             } else {
-                logger.warn("annotation " + annotNode + " has no creator node!");
+                logger.warning("annotation " + annotNode + " has no creator node!");
             }
             /*
@@ -833,5 +833,5 @@
                     deleteNode(annotNode);
                 } else {
-                    logger.error("deleteById: unable to delete: Node still has relations.");
+                    logger.severe("deleteById: unable to delete: Node still has relations.");
                 }
             }
@@ -861,5 +861,5 @@
                             annotations.add(annot);
                         } else {
-                            logger.error("ANNOTATES relation does not start with ANNOTATION: " + ann);
+                            logger.severe("ANNOTATES relation does not start with ANNOTATION: " + ann);
                         }
                     }
@@ -880,5 +880,5 @@
                             annotations.add(annot);
                         } else {
-                            logger.error("CREATED relation does not end with ANNOTATION: " + ann);
+                            logger.severe("CREATED relation does not end with ANNOTATION: " + ann);
                         }
                     }
@@ -1084,5 +1084,5 @@
         try (Transaction tx = graphDb.beginTx()) {
             if (node.hasRelationship()) {
-                logger.error("deleteNode: unable to delete: Node still has relations.");
+                logger.severe("deleteNode: unable to delete: Node still has relations.");
             } else {
                 String ts = (String) node.getProperty("TYPE", null);
@@ -1091,5 +1091,5 @@
                     getNodeIndex(type).remove(node);
                 } catch (Exception e) {
-                    logger.error("deleteNode: unable to get TYPE of node: " + node);
+                    logger.severe("deleteNode: unable to get TYPE of node: " + node);
                 }
                 node.delete();
@@ -1162,5 +1162,5 @@
                     Node rn = rel.getEndNode();
                     if (rn.getProperty("TYPE", "").equals("RESOURCE")) {
-                        logger.error("getAnnotationsByResource got ANNOTATES != RESOURCE");
+                        logger.severe("getAnnotationsByResource got ANNOTATES != RESOURCE");
                     }
                     ret.add(createAnnotationFromNode(an));
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotations.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotations.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotations.java	(revision 75)
@@ -71,5 +71,5 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorAnnotations doGetJSON!");
+        logger.fine("AnnotatorAnnotations doGetJSON!");
         setCorsHeaders();
         // id from URI /annotations/{id}
@@ -84,10 +84,10 @@
             }
             id = decodeJsonId(jsonId);
-            logger.debug("annotation-id=" + id);
+            logger.fine("annotation-id=" + id);
         }
 
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
 
         if (id == null) {
@@ -168,5 +168,5 @@
     @Post("json")
     public Representation doPostJson(Representation entity) {
-        logger.debug("AnnotatorAnnotations doPostJSON!");
+        logger.fine("AnnotatorAnnotations doPostJSON!");
         // set headers
         setCorsHeaders();
@@ -174,5 +174,5 @@
         // do authentication TODO: who's allowed to create?
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
         if (authUser == null) {
             setStatus(Status.CLIENT_ERROR_FORBIDDEN, "Not Authorized!");
@@ -223,14 +223,14 @@
     @Put("json")
     public Representation doPutJSON(Representation entity) {
-        logger.debug("AnnotatorAnnotations doPutJSON!");
+        logger.fine("AnnotatorAnnotations doPutJSON!");
         setCorsHeaders();
         // id from URI /annotations/{id}
         String jsonId = (String) getRequest().getAttributes().get("id");
         String id = decodeJsonId(jsonId);
-        logger.debug("annotation-id=" + id);
+        logger.fine("annotation-id=" + id);
 
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
 
         Annotation annot = null;
@@ -269,8 +269,8 @@
             return retRep;
         } catch (JSONException e) {
-            logger.error("Error in doPutJSON", e);
+            logger.severe("Error in doPutJSON: "+e);
             setStatus(Status.CLIENT_ERROR_BAD_REQUEST);
         } catch (IOException e) {
-            logger.error("Error in doPutJSON", e);
+            logger.severe("Error in doPutJSON: "+e);
             setStatus(Status.SERVER_ERROR_INTERNAL, "Other Error");
         }
@@ -286,14 +286,14 @@
     @Delete("json")
     public Representation doDeleteJSON(Representation entity) {
-        logger.debug("AnnotatorAnnotations doDeleteJSON!");
+        logger.fine("AnnotatorAnnotations doDeleteJSON!");
         setCorsHeaders();
         // id from URI /annotations/{id}
         String jsonId = (String) getRequest().getAttributes().get("id");
         String id = decodeJsonId(jsonId);
-        logger.debug("annotation-id=" + id);
+        logger.fine("annotation-id=" + id);
 
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
         AnnotationStore store = getAnnotationStore();
         Annotation annot = store.getAnnotationById(id);
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByResources.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByResources.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByResources.java	(revision 75)
@@ -56,10 +56,10 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorAnnotatonsByResource doGetJSON!");
+        logger.fine("AnnotatorAnnotatonsByResource doGetJSON!");
         setCorsHeaders();
 
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
 
         String id = null;
@@ -74,5 +74,5 @@
             id = decodeJsonId(jsonId);
             // String id = jsonId;
-            logger.debug("ressource-id=" + id);
+            logger.fine("ressource-id=" + id);
         }
 
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByTags.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByTags.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorAnnotationsByTags.java	(revision 75)
@@ -55,10 +55,10 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorAnnotatonsBytag doGetJSON!");
+        logger.fine("AnnotatorAnnotatonsBytag doGetJSON!");
         setCorsHeaders();
 
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
 
         String id = (String) getRequest().getAttributes().get("id");
@@ -69,5 +69,5 @@
             // this shouldn't happen
         }
-        logger.debug("annotation-id=" + id);
+        logger.fine("annotation-id=" + id);
 
         Form form = getRequest().getResourceRef().getQueryAsForm();
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorGroups.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorGroups.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorGroups.java	(revision 75)
@@ -65,5 +65,5 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorGroups doGetJSON!");
+        logger.fine("AnnotatorGroups doGetJSON!");
         setCorsHeaders();
         Form form = getRequest().getResourceRef().getQueryAsForm();
@@ -99,6 +99,6 @@
             return null;
         }
-        logger.debug("sending:");
-        logger.debug(result);
+        logger.fine("sending:");
+        logger.fine(result.toString());
         return new JsonRepresentation(result);
 
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResourceImpl.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResourceImpl.java	(revision 73)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResourceImpl.java	(revision 75)
@@ -35,4 +35,5 @@
 import java.util.List;
 import java.util.Set;
+import java.util.logging.Logger;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
@@ -46,5 +47,4 @@
 
 import org.apache.commons.codec.binary.Base64;
-import org.apache.log4j.Logger;
 import org.json.JSONArray;
 import org.json.JSONException;
@@ -74,5 +74,5 @@
 public abstract class AnnotatorResourceImpl extends ServerResource {
 
-    protected static Logger logger = Logger.getLogger(AnnotatorResourceImpl.class);
+    protected static Logger logger = Logger.getLogger(AnnotatorResourceImpl.class.toString());
 
     private AnnotationStore store;
@@ -116,5 +116,5 @@
     @Options
     public void doOptions(Representation entity) {
-        logger.debug("AnnotatorResourceImpl doOptions!");
+        logger.fine("AnnotatorResourceImpl doOptions!");
         setCorsHeaders();
     }
@@ -183,9 +183,9 @@
         BaseRestlet restServer = (BaseRestlet) getApplication();
         String consumerSecret = restServer.getConsumerSecret(consumerKey);
-        logger.debug("requested consumer key=" + consumerKey + " secret=" + consumerSecret);
+        logger.fine("requested consumer key=" + consumerKey + " secret=" + consumerSecret);
         if (consumerSecret == null) {
             return null;
         }
-        // logger.debug(String.format("token=%s tokenString=%s signatureAlgorithm=%s",token,token.getTokenString(),token.getSignatureAlgorithm()));
+        // logger.fine(String.format("token=%s tokenString=%s signatureAlgorithm=%s",token,token.getTokenString(),token.getSignatureAlgorithm()));
         try {
             List<Verifier> verifiers = new ArrayList<Verifier>();
@@ -205,5 +205,5 @@
         }
         // must be ok then
-        logger.debug("auth OK! user=" + userId);
+        logger.fine("auth OK! user=" + userId);
         return userId;
     }
@@ -336,5 +336,5 @@
             return jo;
         } catch (JSONException e) {
-            logger.error("Unable to create AnnotatorJSON!", e);
+            logger.severe("Unable to create AnnotatorJSON! "+e);
         }
         return null;
@@ -368,5 +368,5 @@
             }
         } catch (JSONException e) {
-            logger.error("Unable to transform to ranges!", e);
+            logger.severe("Unable to transform to ranges! "+e);
         }
         return ja;
@@ -404,5 +404,5 @@
             }
         } catch (JSONException e) {
-            logger.error("Unable to transform to shapes!", e);
+            logger.severe("Unable to transform to shapes! "+e);
         }
         return ja;
@@ -424,5 +424,5 @@
             fragment = String.format("xywh=fraction:%s,%s,%s,%s", x, y, width, height);
         } else {
-            logger.error("Unable to parse this shape: " + shape);
+            logger.severe("Unable to parse this shape: " + shape);
         }
         return fragment;
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResources.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResources.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorResources.java	(revision 75)
@@ -62,5 +62,5 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorResources doGetJSON!");
+        logger.fine("AnnotatorResources doGetJSON!");
         setCorsHeaders();
 
@@ -76,5 +76,5 @@
         String uri = decodeJsonId(jsonId);
 
-        logger.debug("resources-id=" + uri);
+        logger.fine("resources-id=" + uri);
 
         if (uri == null) {
@@ -123,6 +123,6 @@
             return null;
         }
-        logger.debug("sending:");
-        logger.debug(result);
+        logger.fine("sending:");
+        logger.fine(result.toString());
         return new JsonRepresentation(result);
     }
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorRestlet.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorRestlet.java	(revision 72)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorRestlet.java	(revision 75)
@@ -26,5 +26,4 @@
  */
 
-import org.apache.log4j.Logger;
 import org.restlet.Restlet;
 import org.restlet.routing.Router;
@@ -37,6 +36,4 @@
 
     public final String version = "AnnotationManagerN4J/Annotator 0.3.2";
-
-    public static Logger logger = Logger.getLogger(AnnotatorRestlet.class);
 
     /*
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorSearch.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorSearch.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorSearch.java	(revision 75)
@@ -65,9 +65,9 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorSearch doGetJSON!");
+        logger.fine("AnnotatorSearch doGetJSON!");
         setCorsHeaders();
         // do authentication
         Person authUser = Person.createPersonWithId(this.checkAuthToken(entity));
-        logger.debug("request authenticated=" + authUser);
+        logger.fine("request authenticated=" + authUser);
 
         Form form = getRequest().getResourceRef().getQueryAsForm();
@@ -80,5 +80,5 @@
         // do search
         ArrayList<JSONObject> results = new ArrayList<JSONObject>();
-        logger.debug(String.format("searching for uri=%s user=%s", uri, user));
+        logger.fine(String.format("searching for uri=%s user=%s", uri, user));
         AnnotationStore store = getAnnotationStore();
         List<Annotation> annots = store.searchAnnotationByUriUser(uri, user);
@@ -120,6 +120,6 @@
         }
 
-        logger.debug("sending:");
-        logger.debug(result);
+        logger.fine("sending:");
+        logger.fine(result.toString());
         return new JsonRepresentation(result);
     }
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorTags.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorTags.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/AnnotatorTags.java	(revision 75)
@@ -64,5 +64,5 @@
     @Get("json")
     public Representation doGetJSON(Representation entity) {
-        logger.debug("AnnotatorGroups doGetJSON!");
+        logger.fine("AnnotatorGroups doGetJSON!");
         setCorsHeaders();
 
@@ -70,5 +70,5 @@
         // String id = decodeJsonId(jsonId);
         String id = jsonId;
-        logger.debug("annotation-id=" + id);
+        logger.fine("annotation-id=" + id);
 
         if (id == null) {
@@ -126,6 +126,6 @@
             return null;
         }
-        logger.debug("sending:");
-        logger.debug(result);
+        logger.fine("sending:");
+        logger.fine(result.toString());
         return new JsonRepresentation(result);
     }
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/BaseRestlet.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/BaseRestlet.java	(revision 74)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/BaseRestlet.java	(revision 75)
@@ -32,4 +32,5 @@
 import java.util.Properties;
 import java.util.concurrent.ConcurrentMap;
+import java.util.logging.Logger;
 
 import javax.naming.NamingEnumeration;
@@ -42,6 +43,4 @@
 import javax.servlet.ServletContext;
 
-import org.apache.log4j.BasicConfigurator;
-import org.apache.log4j.Logger;
 import org.neo4j.graphdb.GraphDatabaseService;
 import org.neo4j.graphdb.factory.GraphDatabaseBuilder;
@@ -57,5 +56,5 @@
 public abstract class BaseRestlet extends Application {
 
-    public static Logger logger = Logger.getLogger(BaseRestlet.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.BaseRestlet");
 
     /**
@@ -148,9 +147,5 @@
         ServletContext sc = (ServletContext) attrs.get("org.restlet.ext.servlet.ServletContext");
         if (sc != null) {
-            if (sc.getAttribute("annotationserver.log4j.configured") == null) {
-                // TODO: is this the right place to run the log4j configurator?
-                BasicConfigurator.configure();
-                sc.setAttribute("annotationserver.log4j.configured", "done");
-            }
+            logger = context.getLogger();
             logger.info(getVersion() + " starting...");
 
@@ -163,5 +158,5 @@
                 InputStream ps = getResourceAsStream(sc, CONFIG_PROPS_PATH);
                 if (ps != null) {
-                    logger.debug("loading config from " + CONFIG_PROPS_PATH);
+                    logger.fine("loading config from " + CONFIG_PROPS_PATH);
                     try {
                         serverConfig.load(ps);
@@ -187,9 +182,9 @@
                         }
                     } catch (IOException e) {
-                        logger.warn("Error loading server config: ", e);
+                        logger.warning("Error loading server config: "+e.toString());
                     }
-                    logger.debug("config: " + serverConfig);
+                    logger.fine("config: " + serverConfig);
                 } else {
-                    logger.error("Unable to get resource " + CONFIG_PROPS_PATH);
+                    logger.severe("Unable to get resource " + CONFIG_PROPS_PATH);
                 }
                 // store config
@@ -204,5 +199,5 @@
                 String dbFn = getResourcePath(sc, graphdbPath);
                 if (dbFn != null) {
-                    logger.debug("opening DB " + dbFn);
+                    logger.fine("opening DB " + dbFn);
                     GraphDatabaseBuilder graphDbBuilder = new GraphDatabaseFactory().newEmbeddedDatabaseBuilder(dbFn);
                     graphDbBuilder.setConfig(GraphDatabaseSettings.allow_store_upgrade, "true");
@@ -216,10 +211,10 @@
                     // admin server
                     srv = new WrappingNeoServerBootstrapper((GraphDatabaseAPI) graphDb);
-                    logger.debug("Starting DB admin server...");
+                    logger.fine("Starting DB admin server...");
                     // store in context
                     sc.setAttribute(GRAPHDBSRV_KEY, srv);
                     srv.start();
                 } else {
-                    logger.error("Unable to get resource " + dbFn);
+                    logger.severe("Unable to get resource " + dbFn);
                 }
             } else {
@@ -235,5 +230,5 @@
                 InputStream ps = getResourceAsStream(sc, CONSUMER_KEYS_PATH);
                 if (ps != null) {
-                    logger.debug("loading consumer keys from " + CONSUMER_KEYS_PATH);
+                    logger.fine("loading consumer keys from " + CONSUMER_KEYS_PATH);
                     try {
                         consumerKeys.load(ps);
@@ -242,7 +237,7 @@
                         e.printStackTrace();
                     }
-                    logger.debug("consumer keys: " + consumerKeys);
+                    logger.fine("consumer keys: " + consumerKeys);
                 } else {
-                    logger.error("Unable to get resource " + CONSUMER_KEYS_PATH);
+                    logger.severe("Unable to get resource " + CONSUMER_KEYS_PATH);
                 }
                 // store config
@@ -250,5 +245,5 @@
             }
         } else {
-            logger.error("Unable to get ServletContext!");
+            logger.severe("Unable to get ServletContext!");
         }
     }
@@ -302,5 +297,5 @@
             dctx = new InitialDirContext(env);
         } catch (NamingException e) {
-            logger.error("Error in getFullNameFromLDAP!", e);
+            logger.warning("Error in getFullNameFromLDAP! "+e);
             return retString;
         }
@@ -325,5 +320,5 @@
             }
         } catch (NamingException e) {
-            logger.error("Error in getFullNameFromLDAP!", e);
+            logger.warning("Error in getFullNameFromLDAP!"+e);
         }
 
@@ -331,5 +326,5 @@
             dctx.close();
         } catch (NamingException e) {
-            logger.error("Error in getFullNameFromLDAP!", e);
+            logger.warning("Error in getFullNameFromLDAP!"+e);
         }
         return retString;
@@ -363,9 +358,9 @@
                 File pf = new File(sc.getRealPath(webPath));
                 if (pf.canRead()) {
-                    logger.debug("trying file for: " + pf);
+                    logger.fine("trying file for: " + pf);
                     try {
                         ps = new FileInputStream(pf);
                     } catch (FileNotFoundException e) {
-                        logger.error(e);
+                        logger.severe(e.toString());
                     }
                 } else {
@@ -409,10 +404,10 @@
          */
         if (srv != null) {
-            logger.debug("Stopping DB admin server...");
+            logger.info("Stopping DB admin server...");
             srv.stop();
             srv = null;
         }
         if (graphDb != null) {
-            logger.debug("Stopping DB...");
+            logger.info("Stopping DB...");
             graphDb.shutdown();
             graphDb = null;
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationResource.java	(revision 75)
@@ -28,6 +28,6 @@
 import java.io.UnsupportedEncodingException;
 import java.net.URLDecoder;
-
-import org.apache.log4j.Logger;
+import java.util.logging.Logger;
+
 import org.restlet.data.Form;
 import org.restlet.data.MediaType;
@@ -54,5 +54,5 @@
 public class AnnotationResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(AnnotationResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.AnnotationResource");
 
     protected AnnotationStore store;
@@ -67,5 +67,5 @@
         // id from URI /annotations/persons/{id}
         requestId = (String) getRequest().getAttributes().get("id");
-        logger.debug("annoation-id=" + requestId);
+        logger.fine("annoation-id=" + requestId);
         // get store instance
         if (store == null) {
@@ -149,5 +149,5 @@
     @Put
     public Representation doPut(Representation entity) {
-        logger.debug("AnnotationResource.doPut!");
+        logger.fine("AnnotationResource.doPut!");
         if (annotation == null) {
             // invalid id
@@ -186,5 +186,5 @@
     @Delete
     public Representation doDelete(Representation entity) {
-        logger.debug("AnnotationResource.doDelete!");
+        logger.fine("AnnotationResource.doDelete!");
         if (annotation == null) {
             // invalid id
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsResource.java	(revision 75)
@@ -27,6 +27,6 @@
 
 import java.util.List;
+import java.util.logging.Logger;
 
-import org.apache.log4j.Logger;
 import org.restlet.data.MediaType;
 import org.restlet.data.Reference;
@@ -49,5 +49,5 @@
 public class AnnotationsResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(AnnotationsResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.AnnotationsResource");
 
     private AnnotationStore store;
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsUiRestlet.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsUiRestlet.java	(revision 72)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/AnnotationsUiRestlet.java	(revision 75)
@@ -26,5 +26,6 @@
  */
 
-import org.apache.log4j.Logger;
+import java.util.logging.Logger;
+
 import org.restlet.Restlet;
 import org.restlet.data.ChallengeScheme;
@@ -43,5 +44,5 @@
     public final String version = "AnnotationManagerN4J/AnnotationsUI 0.3";
 
-    public static Logger logger = Logger.getLogger(AnnotationsUiRestlet.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.AnnotationsUiRestlet");
 
     /*
@@ -80,5 +81,5 @@
             verifier.getLocalSecrets().put(user, pw.toCharArray());
         } else {
-            logger.error("Admin user and password missing in serverconfig!");
+            logger.severe("Admin user and password missing in serverconfig!");
         }
         // Create a Guard
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupMembersResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupMembersResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupMembersResource.java	(revision 75)
@@ -96,5 +96,5 @@
     @Post
     public Representation doPost(Representation entity) {
-        logger.debug("GroupMembersResource doPost!");
+        logger.fine("GroupMembersResource doPost!");
         // TODO: do authentication
         Form form = new Form(entity);
@@ -108,5 +108,5 @@
         }
         if (addMemberId != null) {
-            logger.debug("adding member: "+addMemberId);
+            logger.fine("adding member: "+addMemberId);
             Person member = new Person(addMemberId);
             store.addGroupMember(group, member);
@@ -115,5 +115,5 @@
                 delMemberId = delMemberId.substring(7);
             }
-            logger.debug("deleting member: "+delMemberId);
+            logger.fine("deleting member: "+delMemberId);
             Person member = new Person(delMemberId);
             store.deleteGroupMember(group, member);
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupResource.java	(revision 75)
@@ -28,6 +28,6 @@
 import java.io.UnsupportedEncodingException;
 import java.net.URLDecoder;
+import java.util.logging.Logger;
 
-import org.apache.log4j.Logger;
 import org.restlet.data.Form;
 import org.restlet.data.MediaType;
@@ -54,5 +54,5 @@
 public class GroupResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(GroupResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.GroupResource");
 
     protected AnnotationStore store;
@@ -67,5 +67,5 @@
         // id from URI /annotations/groups/{id}
         requestId = (String) getRequest().getAttributes().get("id");
-        logger.debug("group-id=" + requestId);
+        logger.fine("group-id=" + requestId);
         // get store instance
         if (store == null) {
@@ -145,5 +145,5 @@
     @Put
     public Representation doPut(Representation entity) {
-        logger.debug("GroupResource.doPut!");
+        logger.fine("GroupResource.doPut!");
         if (group == null) {
             // invalid id
@@ -178,5 +178,5 @@
     @Delete
     public Representation doDelete(Representation entity) {
-        logger.debug("GroupResource.doDelete!");
+        logger.fine("GroupResource.doDelete!");
         if (group == null) {
             // invalid id
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupsResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupsResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/GroupsResource.java	(revision 75)
@@ -27,6 +27,6 @@
 
 import java.util.List;
+import java.util.logging.Logger;
 
-import org.apache.log4j.Logger;
 import org.restlet.data.Form;
 import org.restlet.data.MediaType;
@@ -53,5 +53,5 @@
 public class GroupsResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(GroupsResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.GroupsResource");
 
     private AnnotationStore store;
@@ -116,5 +116,5 @@
     @Post
     public Representation doPost(Representation entity) {
-        logger.debug("AnnotationsUiGroups doPost!");
+        logger.fine("AnnotationsUiGroups doPost!");
         // TODO: do authentication
         Form form = new Form(entity);
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonResource.java	(revision 75)
@@ -28,6 +28,6 @@
 import java.io.UnsupportedEncodingException;
 import java.net.URLDecoder;
+import java.util.logging.Logger;
 
-import org.apache.log4j.Logger;
 import org.restlet.data.Form;
 import org.restlet.data.MediaType;
@@ -54,5 +54,5 @@
 public class PersonResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(PersonResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.PersonResource");
 
     protected AnnotationStore store;
@@ -67,5 +67,5 @@
         // id from URI /annotations/persons/{id}
         requestId = (String) getRequest().getAttributes().get("id");
-        logger.debug("person-id=" + requestId);
+        logger.fine("person-id=" + requestId);
         // get store instance
         if (store == null) {
@@ -143,5 +143,5 @@
     @Put
     public Representation doPut(Representation entity) {
-        logger.debug("PersonResource.doPut!");
+        logger.fine("PersonResource.doPut!");
         if (person == null) {
             // invalid id
@@ -176,5 +176,5 @@
     @Delete
     public Representation doDelete(Representation entity) {
-        logger.debug("PersonResource.doDelete!");
+        logger.fine("PersonResource.doDelete!");
         if (person == null) {
             // invalid id
Index: src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonsResource.java
===================================================================
--- src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonsResource.java	(revision 70)
+++ src/main/java/de/mpiwg/itgroup/annotations/restlet/annotations_ui/PersonsResource.java	(revision 75)
@@ -27,6 +27,6 @@
 
 import java.util.List;
+import java.util.logging.Logger;
 
-import org.apache.log4j.Logger;
 import org.restlet.data.Form;
 import org.restlet.data.MediaType;
@@ -53,5 +53,5 @@
 public class PersonsResource extends ServerResource {
 
-    public static Logger logger = Logger.getLogger(PersonsResource.class);
+    public static Logger logger = Logger.getLogger("de.mpiwg.itgroup.annotations.restlet.annotations_ui.PersonsResource");
 
     private AnnotationStore store;
@@ -115,5 +115,5 @@
     @Post
     public Representation doPost(Representation entity) {
-        logger.debug("PersonsResource doPost!");
+        logger.fine("PersonsResource doPost!");
         // TODO: do authentication
         Form form = new Form(entity);