Index: css/docuviewer.css
===================================================================
--- css/docuviewer.css	(revision 538)
+++ css/docuviewer.css	(revision 539)
@@ -256,4 +256,8 @@
 	padding-top: 1em;	
 }
+div.index-info h2 {
+	margin-top: 0.5em;
+	margin-bottom: 0.5em;
+}
 div.index-info td.type {
 	font-weight: bold;
Index: zpt/toc_concordance.zpt
===================================================================
--- zpt/toc_concordance.zpt	(revision 537)
+++ zpt/toc_concordance.zpt	(revision 539)
@@ -36,4 +36,7 @@
         </table>
       </div>
+      <div class="ruler">
+        <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
+      </div>
     </div>
   </div>
Index: zpt/toc_figures.zpt
===================================================================
--- zpt/toc_figures.zpt	(revision 537)
+++ zpt/toc_figures.zpt	(revision 539)
@@ -18,4 +18,7 @@
       <div class="content"
         tal:content="structure python:here.getTocPage(mode='figures',start=start,pageinfo=pageinfo,docinfo=docinfo)" />
+      <div class="ruler">
+        <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
+      </div>
     </div>
   </div>
Index: zpt/toc_text.zpt
===================================================================
--- zpt/toc_text.zpt	(revision 537)
+++ zpt/toc_text.zpt	(revision 539)
@@ -17,4 +17,7 @@
       </div>
       <div class="content" tal:content="structure python:here.getTocPage(mode='text',start=start,pageinfo=pageinfo,docinfo=docinfo)" />
+      <div class="ruler">
+        <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler" />
+      </div>
     </div>
   </div>
Index: zpt/toc_thumbs.zpt
===================================================================
--- zpt/toc_thumbs.zpt	(revision 537)
+++ zpt/toc_thumbs.zpt	(revision 539)
@@ -35,4 +35,7 @@
           </tr>
         </table>
+        <div class="ruler">
+          <metal:block metal:use-macro="here/template/common_template/macros/toc_ruler_thumbs" />
+        </div>
       </div>
       <!-- content -->
Index: zpt/viewer_index.zpt
===================================================================
--- zpt/viewer_index.zpt	(revision 538)
+++ zpt/viewer_index.zpt	(revision 539)
@@ -31,4 +31,5 @@
     <div class="col">
       <div class="index-info">
+        <h2>Bibliographical information</h2>
         <table border="0"
           tal:define="formattedData python:here.metadata.getBibFormattedMetaDataExtended(bibdata=docinfo.get('bib', None))">
@@ -66,5 +67,7 @@
         </table>
 
-        <table tal:define="dri docinfo/DRI | nothing" tal:condition="dri">
+        <tal:block tal:define="dri docinfo/DRI | nothing" tal:condition="dri">
+        <h2>Permanent URL</h2>
+        <table>
           <tr>
             <td class="type">Document ID:</td>
@@ -77,13 +80,20 @@
           </tr>
         </table>
+        </tal:block>
 
-        <table border="0">
+        <tal:block tal:define="attribution docinfo/attribution | nothing; copyright docinfo/copyright | nothing">
+        <h2>Copyright information</h2>
+        <table border="0" tal:condition="attribution | copyright">
           <!-- attribution -->
-          <tr tal:condition="exists:docinfo/attribution"
-            tal:replace="structure python:here.metadataService.getAttributionFormatted('metadata_template', data=docinfo['attribution'])" />
+          <tr tal:condition="attribution"
+            tal:replace="structure python:here.metadataService.getAttributionFormatted('metadata_template', data=attribution)" />
           <!-- copyright -->
-          <tr tal:condition="exists:docinfo/copyright"
-            tal:replace="structure python:here.metadataService.getCopyrightFormatted('metadata_template', data=docinfo['copyright'])" />
+          <tr tal:condition="copyright"
+            tal:replace="structure python:here.metadataService.getCopyrightFormatted('metadata_template', data=copyright)" />
         </table>
+        <table border="0" tal:condition="not:attribution | copyright">
+          <tr><td></td></tr>
+        </table>        
+        </tal:block>
       </div>
 