Index: MpdlXmlTextServer.py
===================================================================
--- MpdlXmlTextServer.py	(revision 432)
+++ MpdlXmlTextServer.py	(revision 434)
@@ -184,6 +184,4 @@
         name = docinfo.get('name',None)
         pn =pageinfo['current']
-        #viewMode= pageinfo['viewMode']
-        
         sn = pageinfo['sn']
         highlightQuery = pageinfo['highlightQuery']
@@ -210,5 +208,5 @@
             if len(pagedivs)>0:
                 docinfo['pageNumberOrig']= getTextFromNode(pagedivs[0])
-                logging.debug("ORIGINAL PAGES: %s"%(docinfo['pageNumberOrig']))
+                #logging.debug("ORIGINAL PAGES: %s"%(docinfo['pageNumberOrig']))
         
         #original Pages Norm
@@ -217,5 +215,5 @@
             if len(pagedivs)>0:
                 docinfo['pageNumberOrigNorm']= getTextFromNode(pagedivs[0])
-                logging.debug("ORIGINAL PAGES: %s"%(docinfo['pageNumberOrigNorm']))
+                #logging.debug("ORIGINAL PAGES: %s"%(docinfo['pageNumberOrigNorm']))
 
         
@@ -229,5 +227,5 @@
                     try:
                         docinfo['countFigureEntries'] = int(s)
-                        logging.debug("FIGURE ENTRIES: %s"%(s))
+                        #logging.debug("FIGURE ENTRIES: %s"%(s))
                     except:
                         docinfo['countFigureEntries'] = 0
@@ -236,5 +234,5 @@
                     try:
                         docinfo['countFigureEntries'] = int(s1)
-                        logging.debug("FIGURE ENTRIES: %s"%(s1))
+                        #logging.debug("FIGURE ENTRIES: %s"%(s1))
                     except:
                         docinfo['countFigureEntries'] = 0      
@@ -248,5 +246,5 @@
                 try:
                     docinfo['countPlaces'] = int(s)
-                    logging.debug("PLACES HERE: %s"%(s))
+                    #logging.debug("PLACES HERE: %s"%(s))
                 except:
                     docinfo['countPlaces'] = 0
@@ -261,5 +259,5 @@
                     try:
                         docinfo['countTocEntries'] = int(s)
-                        logging.debug("TEXT ENTRIES: %s"%(s))
+                        #logging.debug("TEXT ENTRIES: %s"%(s))
                     except:
                         docinfo['countTocEntries'] = 0
@@ -268,5 +266,5 @@
                     try:
                         docinfo['countTocEntries'] = int(s1)
-                        logging.debug("TEXT ENTRIES: %s"%(s1))
+                        #logging.debug("TEXT ENTRIES: %s"%(s1))
                     except:
                         docinfo['countTocEntries'] = 0
@@ -281,5 +279,5 @@
                 try:
                     docinfo['numPages'] = int(s)
-                    logging.debug("PAGE NUMBER: %s"%(s))
+                    #logging.debug("PAGE NUMBER: %s"%(s))
                 
                     np = docinfo['numPages']
@@ -409,12 +407,12 @@
          numdivs = pagedom.xpath("//div[@class='queryResultHits']")
          tocSearch = int(getTextFromNode(numdivs[0]))
-         logging.debug("documentViewer (gettoc) tocSearch: %s"%(tocSearch))
+         #logging.debug("documentViewer (gettoc) tocSearch: %s"%(tocSearch))
          tc=int((tocSearch/10)+1)
-         logging.debug("documentViewer (gettoc) tc: %s"%(tc))
+         #logging.debug("documentViewer (gettoc) tc: %s"%(tc))
          return tc
     
     def getToc(self, mode="text", docinfo=None):
         """loads table of contents and stores in docinfo"""
-        logging.debug("documentViewer (gettoc) mode: %s"%(mode))
+        #logging.debug("documentViewer (gettoc) mode: %s"%(mode))
         if mode == "none":
             return docinfo        
@@ -469,5 +467,5 @@
         text = page.replace('mode=image','mode=texttool')
         #logging.debug("documentViewer (characterNormalization) characterNormalization: %s"%(characterNormalization))
-        logging.debug("TEXT %s"%(text))
+        #logging.debug("TEXT %s"%(text))
         return text
     
Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 432)
+++ documentViewer.py	(revision 434)
@@ -767,4 +767,6 @@
             textUrl = getTextFromNode(textUrls[0])
             docinfo['textURLPath'] = textUrl
+            textUrlkurz = string.split(textUrl, ".")[0]
+            docinfo['textURLPathkurz'] = textUrlkurz
             #if not docinfo['imagePath']:
                 # text-only, no page images