Index: css/docuviewer.css
===================================================================
--- css/docuviewer.css	(revision 488)
+++ css/docuviewer.css	(revision 489)
@@ -16,5 +16,5 @@
 }
 
-div.col-left.text {
+div.toc-text, div.toc-figures {
     max-width: 20em;
 }
Index: documentViewer.py
===================================================================
--- documentViewer.py	(revision 488)
+++ documentViewer.py	(revision 489)
@@ -3,4 +3,5 @@
 from Products.PageTemplates.PageTemplateFile import PageTemplateFile
 from App.ImageFile import ImageFile
+from App.Common import rfc1123_date
 #from Products.ZSimpleFile.ZSimpleFile import ZSimpleFile
 from AccessControl import ClassSecurityInfo
@@ -10,5 +11,6 @@
 import xml.etree.ElementTree as ET
 
-import os.path
+import os
+import stat
 import sys
 import urllib
@@ -105,4 +107,12 @@
     return '/'.join(path.split('/')[0:-cnt])
 
+def devImageFileIndexHtml(self, REQUEST, RESPONSE):
+    """index_html method for App.ImageFile that updates the file info for each request."""
+    stat_info = os.stat(self.path)
+    self.size = stat_info[stat.ST_SIZE]
+    self.lmt = float(stat_info[stat.ST_MTIME]) or time.time()
+    self.lmh = rfc1123_date(self.lmt)
+    # call original method
+    return ImageFile.index_html(self, REQUEST, RESPONSE)
 
 ##
@@ -137,6 +147,7 @@
     head_main = PageTemplateFile('zpt/head_main', globals())
     info_xml = PageTemplateFile('zpt/info_xml', globals())
-    # TODO: can this be nicer?
     docuviewer_css = ImageFile('css/docuviewer.css',globals())
+    # make ImageFile better for development
+    docuviewer_css.index_html = devImageFileIndexHtml
     
     
Index: zpt/head_main.zpt
===================================================================
--- zpt/head_main.zpt	(revision 480)
+++ zpt/head_main.zpt	(revision 489)
@@ -13,7 +13,7 @@
                bib docinfo/bib | nothing; bibType docinfo/bibType | nothing;
                formattedLabel python:here.metadataService.getBibFormattedLabel(bibdata=bib);">
-    <span tal:condition="not:formattedLabel"
+    <div tal:condition="not:formattedLabel"
       tal:content="string:(no bibliographical information for ${bibType})" />
-    <span tal:condition="formattedLabel" tal:content="structure formattedLabel" />
+    <div tal:condition="formattedLabel" tal:content="structure formattedLabel" />
   </metal:block>
 </body>
Index: zpt/toc_figures.zpt
===================================================================
--- zpt/toc_figures.zpt	(revision 488)
+++ zpt/toc_figures.zpt	(revision 489)
@@ -7,5 +7,5 @@
 <body>
   <!-- block used for main content area -->
-  <div class="col-left" metal:define-macro="main"
+  <div class="toc-figures" metal:define-macro="main"
     tal:define="start pageinfo/start; tocsize docinfo/tocSize_figures; grpsize pageinfo/tocPageSize;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
Index: zpt/toc_text.zpt
===================================================================
--- zpt/toc_text.zpt	(revision 488)
+++ zpt/toc_text.zpt	(revision 489)
@@ -7,5 +7,5 @@
 <body>
   <!-- block used for main content area -->
-  <div class="col-left" metal:define-macro="main"
+  <div class="toc-text" metal:define-macro="main"
     tal:define="start pageinfo/start; tocsize docinfo/tocSize_text; grpsize pageinfo/tocPageSize;
                 batch python:here.getBatch(start=start,size=grpsize,end=tocsize);">
Index: zpt/toc_thumbs.zpt
===================================================================
--- zpt/toc_thumbs.zpt	(revision 488)
+++ zpt/toc_thumbs.zpt	(revision 489)
@@ -7,5 +7,5 @@
 <body>
   <!-- block used for main content area -->
-  <div class="col-left" metal:define-macro="main"
+  <div class="toc-thumbs" metal:define-macro="main"
     tal:define="start pageinfo/start;
                 grpsize pageinfo/groupsize;
Index: zpt/viewer_images.zpt
===================================================================
--- zpt/viewer_images.zpt	(revision 485)
+++ zpt/viewer_images.zpt	(revision 489)
@@ -54,5 +54,7 @@
     <div class="page-body" tal:condition="python:here.isAccessible(docinfo)">
       <!--table of contents-->
-      <div class="col-left" metal:use-macro="python:path('here/template/toc_%s/macros/main'%tocMode)" />
+      <div class="col-left">
+        <metal:block metal:use-macro="python:path('here/template/toc_%s/macros/main'%tocMode)" />
+      </div>
       <!-- text page -->
       <div class="col-main">
Index: zpt/viewer_text.zpt
===================================================================
--- zpt/viewer_text.zpt	(revision 485)
+++ zpt/viewer_text.zpt	(revision 489)
@@ -22,6 +22,7 @@
   <div class="page-body" tal:condition="python:here.isAccessible(docinfo)">
     <!--table of contents-->
-    <div class="col-left"
-      metal:use-macro="python:path('here/template/toc_%s/macros/main'%tocMode)" />
+    <div class="col-left">
+      <metal:block metal:use-macro="python:path('here/template/toc_%s/macros/main'%tocMode)" />
+    </div>
 
     <!-- text page -->